package cz.zcu.kiv.aswi.svk.rejstrik;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import cz.zcu.kiv.aswi.maploc.locator.Locator;
import cz.zcu.kiv.aswi.maploc.register.MapPoiReference;

public class PoiObject implements MapPoiReference {
	String locatorName;
	Locator locatorObject;
	Long objectId;
	Map<String, String> parameters;

	public PoiObject(String locator, Map<String, String> parameters) {
		this.locatorName = locator;
		this.parameters = parameters;

		locatorObject = null;
		objectId = -1L;
	}

	public boolean register(List<Locator> availableLocators) {

		for (Locator locator : availableLocators) {
			if (locator.getIdentificator().equalsIgnoreCase(locatorName)) {
				locatorObject = locator;
				objectId = locator.addObject((Map<String, Object>) ((Object)parameters));
				return true;
			}
		}
		return false;
	}

	public void unregister() {
		if (locatorObject == null || objectId == -1L)
			return;

		locatorObject.deleteObject(objectId);
		objectId = -1L;
		locatorObject = null;
	}

	public double[] getLocation() {
		//TODO osetreni, ze objekt neni zaregistrovan
		if (locatorObject == null)
			return new double[] {0, 0};
		return locatorObject.getLocation(objectId);
	}

	@Override
	public double getLatitude() {
		return getLocation()[0];
	}

	@Override
	public double getLongitude() {
		return getLocation()[1];
	}

	@Override
	public Map<String, Object> getParameters() {
		if (locatorObject == null) {
			Map<String, Object> status = new Hashtable<String, Object>();
			status.put("available", Boolean.toString(false));
			return status;
		}

		return locatorObject.getObjectStatus(objectId);
	}
}
