/**
 * Natn konfigurace z xml souboru
 */
package cz.zcu.kiv.aswi.svk.rejstrik.konfigurace;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

import cz.zcu.kiv.aswi.svk.rejstrik.PoiGroup;
import cz.zcu.kiv.aswi.svk.rejstrik.PoiObject;

/**
 *
 *
 */
public class Konfigurace extends DefaultHandler {

	// seznam skupin objekt z konfiguranho souboru
	private static ArrayList<PoiGroup> groups = new ArrayList<PoiGroup>();
	// jmno konfiguranho souboru
	private static String jmeno_souboru = "Konfigurace.xml";


	// pomocn promnn pi parsovn xml dokumentu
	private PoiGroup tmp_group;
	private PoiObject tmp_object;
	private Hashtable<String, String> tmp_preferences = new Hashtable<String, String>();
	private ArrayList<PoiObject> tmp_objects = new ArrayList<PoiObject>();
	private Hashtable<String, String> tmp_parameters = new Hashtable<String, String>();
	private String tmp_name;
	private String tmp_icon;
	private String tmp_desc;
	private String tmp_locator;
	private String tmp_parameter_name;
	private String tmp_parameter;
	private StringBuffer buffer = new StringBuffer();



	public static List<PoiGroup> nacti() {

		try {

			SAXParserFactory parserFactory = SAXParserFactory.newInstance();
			parserFactory.setValidating(false);
			SAXParser parser = parserFactory.newSAXParser();
			XMLReader reader = parser.getXMLReader();

			Konfigurace konfigurace = new Konfigurace();
			reader.setContentHandler(konfigurace);
			reader.setErrorHandler(konfigurace);
			reader.parse(jmeno_souboru);

		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return Konfigurace.groups;
	}

	@Override
	public void startDocument() throws SAXException {

		//System.out.println("Nacitani konfigurace ...");

	}

	@Override
	public void startElement(String uri, String localName, String name,
			Attributes attributes) throws SAXException {

		// smatn bufferu ped natnm novch dat
		if(name.equals("name") || name.equals("icon") || name.equals("desc") ||
				name.equals("locator") || name.equals("parameter")){

			buffer.setLength(0);
		}

		// zan nov skupina objekt
		if(name.equals("group")){
			// odstrann pedel skupiny
			tmp_group = null;
			// przdn preference a seznam objekt pro novou skupinu
			tmp_preferences = new Hashtable<String, String>();
			tmp_objects = new ArrayList<PoiObject>();
		}

		// zan nov objekt
		if(name.equals("object")){
			// odstrann pedelho objektu
			tmp_object = null;
			// przdn parametry pro nov objekt
			tmp_parameters = new Hashtable<String, String>();
		}

		// zan nov laktor
		if(name.equals("locator")){
			// vymazn jmna
			tmp_name = null;
		}


		//if(name.equals("parameters")){}

		// zan nov parametr objektu
		if(name.equals("parameter")){
			// uloen jmna parametru
			tmp_parameter_name = attributes.getValue(0);
		}

	}


	@Override
	public void endDocument() throws SAXException {

		//System.out.println("Konfigurace nactena.");

	}

	@Override
	public void endElement(String uri, String localName, String name)
			throws SAXException {


		// konec skupiny objekt
		if(name.equals("group")){
			// uloen natench hodnot pro skupinu objekt
			tmp_group = new PoiGroup(tmp_preferences, tmp_objects);
			// pidn skupiny objekt do seznamu skupin objekt
			Konfigurace.groups.add(tmp_group);
		}

		// konec jmna skupiny
		if(name.equals("name")){
			// uloen jmna skupiny
			tmp_name = buffer.toString();
			// a pidn jmna mezi preference skupiny
			tmp_preferences.put("name", tmp_name);

		}

		// konec adresy souboru pro ikonu skupiny
		if(name.equals("icon")){
			// uloen souboru s ikonou
			tmp_icon = buffer.toString();
			// a pidn jmna mezi preference skupiny
			tmp_preferences.put("icon", tmp_icon);

		}

		// konec popisu skupiny
		if(name.equals("desc")){
			// uloen popisu skupiny
			tmp_desc = buffer.toString();
			// a pidn jmna mezi preference skupiny
			tmp_preferences.put("desc", tmp_desc);

		}

		// konec objektu ve skupin
		if(name.equals("object")){
			// uloen natench dat
			tmp_object = new PoiObject(tmp_locator, tmp_parameters);
			// pidn do seznamu objekt skupiny
			tmp_objects.add(tmp_object);
			// smazn parametr
			tmp_parameters = null;

		}

		// konec locatoru objektu
		if(name.equals("locator")){
			// uloen natench dat
			tmp_locator = buffer.toString();
		}

		// konec parametru objektu
		if(name.equals("parameter")){
			// uloen naten hodnoty
			tmp_parameter = buffer.toString();
			// pidn mezi parametry
			tmp_parameters.put(tmp_parameter_name, tmp_parameter);

		}

	}


	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {

		buffer.append(ch, start, length);

	}



}
