package cz.zcu.kiv.aswi.svk.webui;

import java.util.Hashtable;
import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cz.zcu.kiv.aswi.maploc.register.MapPoiGroup;
import cz.zcu.kiv.aswi.maploc.register.MapPoiReference;
import cz.zcu.kiv.aswi.maploc.register.Register;

public class WebUiApi extends RestServlet {
	private static final long serialVersionUID = -5819848203154492536L;
	private Register r;

	public WebUiApi(Register register) {
		r = register;
	}

	private JSONArray getObjectsJSON(final Iterator<MapPoiReference> objects) throws JSONException {
		JSONArray arr = new JSONArray();
		for (Iterator<MapPoiReference> iterator = objects; iterator.hasNext();) {
			MapPoiReference object = iterator.next();

			if (!object.getParameters().containsKey("available") || object.getParameters().get("available") == "true") {
				JSONObject item = new JSONObject(object.getParameters());
				item.put("lat", object.getLatitude());
				item.put("lng", object.getLongitude());
				arr.put(item);
			} else {
				JSONObject item = new JSONObject();
				item.put("available", "false");
				arr.put(item);
			}
		}
		return arr;
	}

	public Object getGroup(final JSONObject in) throws Exception {

		if (in.has("name")) {
			Object value = in.get("name");
			if (value instanceof JSONArray) {
				JSONArray valueArray = (JSONArray) value;
				JSONArray arr = new JSONArray();

				Hashtable<String, MapPoiGroup> table = new Hashtable<String, MapPoiGroup>();
				for (Iterator<MapPoiGroup> iterator = r.getGroupsOfPoi(); iterator.hasNext();) {
					MapPoiGroup group = iterator.next();
					table.put(group.getParameters().get("name").toString(), group);
				}
				for (int i = 0; i < valueArray.length(); i++) {
					String name = valueArray.getString(i);
					MapPoiGroup group = table.get(name);

					if (group == null) {
						arr.put(JSONObject.NULL);
						continue;
					}

					JSONObject item = new JSONObject(group.getParameters());
					item.put("objects", getObjectsJSON(group.getObjectsOfGroup()));
					arr.put(item);

				}

				return arr;
			} else {
				String valueString = value.toString();

				for (Iterator<MapPoiGroup> iterator = r.getGroupsOfPoi(); iterator.hasNext();) {
					MapPoiGroup group = iterator.next();

					if (group.getParameters().get("name").toString().equalsIgnoreCase(valueString)) {
						JSONObject item = new JSONObject(group.getParameters());
						item.put("objects", getObjectsJSON(group.getObjectsOfGroup()));
						return new JSONArray().put(item);
					}
				}
				return JSONObject.NULL;
			}
		} else {
			JSONArray arr = new JSONArray();
			for (Iterator<MapPoiGroup> iterator = r.getGroupsOfPoi(); iterator.hasNext();) {
				MapPoiGroup group = iterator.next();

				JSONObject item = new JSONObject();
				item.put("name", group.getParameters().get("name"));
				item.put("picture", group.getParameters().get("picture"));

				arr.put(item);
			}
			return arr;
		}
	}




}
